"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OracleDb = void 0;
const oracledb = __importStar(require("oracledb"));
const Logger_1 = require("../Logger");
class OracleDb {
    getDriver() {
        return oracledb;
    }
    async getOrCreatePool({ user, password, connectString }) {
        try {
            return oracledb.getPool();
        }
        catch (e) {
            if (e.message.includes('NJS-047')) {
                return await oracledb.createPool({
                    connectString,
                    user,
                    password,
                    poolIncrement: 1,
                    poolMax: 3,
                    poolMin: 0,
                });
            }
            else {
                Logger_1.logger.error(e.message);
            }
        }
    }
    async closePool() {
        try {
            await oracledb.getPool().close();
        }
        catch (e) {
            Logger_1.logger.error(e.message);
        }
    }
}
exports.OracleDb = OracleDb;
